﻿Imports System.Data.SqlClient
Public Class FUsuarios
    Inherits Conexion
    Dim Cmd As New SqlCommand
    Public Function Mostrar() As DataTable
        Try
            Conectado()
            Cmd = New SqlCommand("mostrar_usuario")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            If Cmd.ExecuteNonQuery Then
                Dim Dt As New DataTable
                Dim Da As New SqlDataAdapter(Cmd)
                Da.Fill(Dt)
                Return Dt
            Else
                Return Nothing
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return Nothing
        Finally
            Desconectado()
        End Try
    End Function
    Public Function Insertar(ByVal Dts As VUsuarios) As Boolean
        Try
            Conectado()
            Cmd = New SqlCommand("insertar_usuario")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.AddWithValue("@usuario", Dts.gUsuario)
            Cmd.Parameters.AddWithValue("@clave", Dts.gClave)
            Cmd.Parameters.AddWithValue("@nombres", Dts.gNombres)
            Cmd.Parameters.AddWithValue("@apellidos", Dts.gApellidos)
            Cmd.Parameters.AddWithValue("@administrar", Dts.gAdministrar)
            If Cmd.ExecuteNonQuery Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
    Public Function Editar(ByVal Dts As VUsuarios) As Boolean
        Try
            Conectado()
            Cmd = New SqlCommand("editar_usuario")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.AddWithValue("@idusuario", Dts.gIdUsuario)
            Cmd.Parameters.AddWithValue("@usuario", Dts.gUsuario)
            Cmd.Parameters.AddWithValue("@clave", Dts.gClave)
            Cmd.Parameters.AddWithValue("@nombres", Dts.gNombres)
            Cmd.Parameters.AddWithValue("@apellidos", Dts.gApellidos)
            Cmd.Parameters.AddWithValue("@administrar", Dts.gAdministrar)
            If Cmd.ExecuteNonQuery Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
    Public Function Eliminar(ByVal Dts As VUsuarios) As Boolean
        Try
            Conectado()
            Cmd = New SqlCommand("eliminar_usuario")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.Add("@idusuario", SqlDbType.NVarChar, 50).Value = Dts.gIdUsuario
            If Cmd.ExecuteNonQuery Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
    Public Function ValidarUsuario(ByVal Dts As VUsuarios)
        Try
            Conectado()
            Cmd = New SqlCommand("validar_usuario")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.AddWithValue("@usuario", Dts.gUsuario)
            Cmd.Parameters.AddWithValue("@clave", Dts.gClave)
            Dim Dr As SqlDataReader
            Dr = Cmd.ExecuteReader
            If Dr.HasRows = True Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
    Public Function ValidarAdministrador(ByVal Dts As VUsuarios)
        Try
            Conectado()
            Cmd = New SqlCommand("validar_administrador")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.AddWithValue("@usuario", Dts.gUsuario)
            Cmd.Parameters.AddWithValue("@clave", Dts.gClave)
            Cmd.Parameters.AddWithValue("@administrar", Dts.gAdministrar)
            Dim Dr As SqlDataReader
            Dr = Cmd.ExecuteReader
            If Dr.HasRows = True Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
End Class
