﻿Public Class FrmAgregarContacto
    Private Dt As New DataTable
    Private Titulo As String = "GB Agenda v1.0.0"
    Private Sub FrmAgregarContacto_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Mostrar()
        Limpiar()
        BtnEliminar.Enabled = False
        Me.Text = Titulo
    End Sub
    Private Sub Mostrar()
        Try
            Dim Func As New FContactos
            Dt = Func.Mostrar
            DataContactos.Columns.Item("ELIMINAR").Visible = False
            If Dt.Rows.Count <> 0 Then
                DataContactos.DataSource = Dt
                TxtBuscar.Enabled = True
                DataContactos.ColumnHeadersVisible = True
                DataContactos.Columns(2).HeaderText = "Nombre(s)"
                DataContactos.Columns(3).HeaderText = "Apellido(s)"
                DataContactos.Columns(4).HeaderText = "Empresa"
                DataContactos.Columns(5).HeaderText = "Puesto"
                DataContactos.Columns(6).HeaderText = "Tel. Empresa"
                DataContactos.Columns(7).HeaderText = "Extencion"
                DataContactos.Columns(8).HeaderText = "Correo Empresa"
                DataContactos.Columns(9).HeaderText = "Celular"
                DataContactos.Columns(10).HeaderText = "Notas"
                DataContactos.Columns(11).HeaderText = "Correo Personal"
                Inexistente.Visible = False
            Else
                DataContactos.DataSource = Nothing
                TxtBuscar.Enabled = False
                DataContactos.ColumnHeadersVisible = False
                Inexistente.Visible = True
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
        BtnNuevo.Enabled = True
        BtnEditar.Enabled = False
        Buscar()
    End Sub
    Private Sub Buscar()
        Try
            Dim Ds As New DataSet
            Ds.Tables.Add(Dt.Copy)
            Dim Dv As New DataView(Ds.Tables(0))
            Dv.RowFilter = CmbBuscar.Text & " LIKE '%" & TxtBuscar.Text & "%'"
            If Dv.Count <> 0 Then
                Inexistente.Visible = False
                DataContactos.DataSource = Dv
                OcultarColumnas()
            Else
                Inexistente.Visible = True
                DataContactos.DataSource = Nothing
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub
    Private Sub Limpiar()
        BtnGuardar.Enabled = True
        BtnEditar.Enabled = False
        TxtIdContacto.Text = ""
        TxtNombres.Text = ""
        TxtApellidos.Text = ""
        TxtEmpresa.Text = ""
        TxtPuesto.Text = ""
        TxtTelEmp.Text = ""
        TxtExtEmp.Text = ""
        TxtCorEmp.Text = ""
        TxtCel.Text = ""
        TxtNotas.Text = ""
        TxtCorePer.Text = ""
    End Sub
    Private Sub OcultarColumnas()
        DataContactos.Columns(1).Visible = False
    End Sub

    Private Sub TxtNombres_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles TxtNombres.Validating
        If DirectCast(sender, TextBox).Text.Length > 0 Then
            ErrorContacto.SetError(sender, "")
        Else
            ErrorContacto.SetError(sender, "CAMPO OBLIGATORIO")
        End If
    End Sub

    Private Sub ChEliminar_CheckedChanged(sender As Object, e As EventArgs) Handles ChEliminar.CheckedChanged
        If ChEliminar.CheckState = CheckState.Checked Then
            DataContactos.Columns.Item("ELIMINAR").Visible = True
            BtnEliminar.Enabled = True
        Else
            DataContactos.Columns.Item("ELIMINAR").Visible = False
            BtnEliminar.Enabled = False
        End If
    End Sub

    Private Sub BtnNuevo_Click(sender As Object, e As EventArgs) Handles BtnNuevo.Click
        Limpiar()
        Mostrar()
        ChEliminar.Checked = False
    End Sub

    Private Sub BtnGuardar_Click(sender As Object, e As EventArgs) Handles BtnGuardar.Click
        If TxtNombres.Text = "" Then
            ErrorContacto.SetError(TxtNombres, "CAMPO OBLIGATORIO")
        Else
            Try
                Dim Dts As New VContactos
                Dim Func As New FContactos
                Dts.gNombres = TxtNombres.Text
                Dts.gApellidos = TxtApellidos.Text
                Dts.gEmpresa = TxtEmpresa.Text
                Dts.gPuesto = TxtPuesto.Text
                Dts.gTelEmp = TxtTelEmp.Text
                Dts.gExtEmp = TxtExtEmp.Text
                Dts.gCorEmp = TxtCorEmp.Text
                Dts.gCel = TxtCel.Text
                Dts.gNotas = TxtNotas.Text
                Dts.gCorePer = TxtCorePer.Text
                If Func.Insertar(Dts) Then
                    'MsgBox("Contacto Registrado Exitosamente", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, Titulo)
                    FrmNotificacion.Label1.Text = "Contacto Registrado"
                    FrmNotificacion.Show()
                    Mostrar()
                    Limpiar()
                Else
                    MsgBox("El Contacto No Se Pudo Registrar", MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation, Titulo)
                    Mostrar()
                End If
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        End If
    End Sub

    Private Sub DataContactos_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataContactos.CellContentClick
        If e.ColumnIndex = Me.DataContactos.Columns.Item("ELIMINAR").Index Then
            Dim Chkcell As DataGridViewCheckBoxCell = Me.DataContactos.Rows(e.RowIndex).Cells("ELIMINAR")
            Chkcell.Value = Not Chkcell.Value
        End If
    End Sub

    Private Sub DataContactos_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataContactos.CellClick
        TxtIdContacto.Text = DataContactos.SelectedCells.Item(1).Value
        TxtNombres.Text = DataContactos.SelectedCells.Item(2).Value
        TxtApellidos.Text = DataContactos.SelectedCells.Item(3).Value
        TxtEmpresa.Text = DataContactos.SelectedCells.Item(4).Value
        TxtPuesto.Text = DataContactos.SelectedCells.Item(5).Value
        TxtTelEmp.Text = DataContactos.SelectedCells.Item(6).Value
        TxtExtEmp.Text = DataContactos.SelectedCells.Item(7).Value
        TxtCorEmp.Text = DataContactos.SelectedCells.Item(8).Value
        TxtCel.Text = DataContactos.SelectedCells.Item(9).Value
        TxtNotas.Text = DataContactos.SelectedCells.Item(10).Value
        TxtCorePer.Text = DataContactos.SelectedCells.Item(11).Value
        BtnEditar.Enabled = True
        BtnGuardar.Enabled = False
    End Sub

    Private Sub BtnEditar_Click(sender As Object, e As EventArgs) Handles BtnEditar.Click
        If TxtNombres.Text = "" Then
            ErrorContacto.SetError(TxtNombres, "CAMPO OBLIGATORIO")
        Else
            Try
                Dim Dts As New VContactos
                Dim Func As New FContactos
                Dts.gIdContacto = TxtIdContacto.Text
                Dts.gNombres = TxtNombres.Text
                Dts.gApellidos = TxtApellidos.Text
                Dts.gEmpresa = TxtEmpresa.Text
                Dts.gPuesto = TxtPuesto.Text
                Dts.gTelEmp = TxtTelEmp.Text
                Dts.gExtEmp = TxtExtEmp.Text
                Dts.gCorEmp = TxtCorEmp.Text
                Dts.gCel = TxtCel.Text
                Dts.gNotas = TxtNotas.Text
                Dts.gCorePer = TxtCorePer.Text
                If Func.Editar(Dts) Then
                    MsgBox("Contacto Modificado Exitosamente", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, Titulo)
                    Mostrar()
                    Limpiar()
                Else
                    MsgBox("El Contacto No Se Pudo Modificar", MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation, Titulo)
                    Mostrar()
                End If
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        End If
    End Sub

    Private Sub BtnEliminar_Click(sender As Object, e As EventArgs) Handles BtnEliminar.Click
        Dim Pregunta As MsgBoxResult
        Pregunta = MsgBox("¿Realmente Desea Eliminar Los Contactos Seleccionados?" _
                   & vbNewLine & "Se Eliminaran Todos Los Eventos De Los Contactos Anteriores y Futuros",
                   MsgBoxStyle.YesNo + MsgBoxStyle.Question)
        If Pregunta = MsgBoxResult.Yes Then
            Try
                For Each Row As DataGridViewRow In DataContactos.Rows
                    Dim Marcado As Boolean = Convert.ToBoolean(Row.Cells("ELIMINAR").Value)
                    If Marcado Then
                        Dim OneKey As Integer = Convert.ToInt32(Row.Cells("idcontacto").Value)
                        Dim Vdb As New VContactos
                        Dim Vdb2 As New VEventos
                        Dim Func As New FContactos
                        Dim Func2 As New FEventos
                        Vdb2.gIdContacto = OneKey
                        Vdb.gIdContacto = OneKey
                        If Func2.Eliminar(Vdb2) Then
                        Else

                        End If
                        If Func.Eliminar(Vdb) Then
                        Else
                            MsgBox("No Se Pudo Eliminar El Contacto", MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation)
                            End If
                        End If
                Next
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        Else

        End If
        ChEliminar.Checked = False
        Mostrar()
        FrmInicio.Mostrar()
        FrmInicio.Mostrar2()
        FrmInicio.Mostrar3()
        Limpiar()
    End Sub

    Private Sub TxtBuscar_TextChanged(sender As Object, e As EventArgs) Handles TxtBuscar.TextChanged
        Mostrar()
    End Sub

    Private Sub DataContactos_DoubleClick(sender As Object, e As EventArgs) Handles DataContactos.DoubleClick
        If Inexistente.Visible = False Then
            If FrmAgregarEventos.Visible = True Then
                FrmAgregarEventos.TxtIdContacto.Text = DataContactos.SelectedCells.Item(1).Value
                FrmAgregarEventos.TxtNombres.Text = DataContactos.SelectedCells.Item(2).Value
                FrmAgregarEventos.TxtEmpresa.Text = DataContactos.SelectedCells.Item(4).Value
                Me.Close()
            Else
                FrmAgregarEventos.TxtIdContacto.Text = DataContactos.SelectedCells.Item(1).Value
                FrmAgregarEventos.TxtNombres.Text = DataContactos.SelectedCells.Item(2).Value
                FrmAgregarEventos.TxtEmpresa.Text = DataContactos.SelectedCells.Item(4).Value
                FrmAgregarEventos.Show()
            End If
        End If
    End Sub

    Private Sub BtnCancelar_Click(sender As Object, e As EventArgs) Handles BtnCancelar.Click
        Me.Close()
    End Sub
End Class